#!/usr/bin/env python
#----------------------------------------------------------------------------
# Name:         Document.py
# Author:       Bjoern
# Created:      09/24/2001
# Copyright:    (c) 2001 SKYRiX Software AG
#----------------------------------------------------------------------------

import string

# factory
def create(_class, *_args):
  return apply(_class, _args)

# Document
class Document:

  # __init__
  def __init__(self, _ds = None, _object = None):
    "__init__"
    self.object = {}

    if _object != None: self.object = _object 
    if _ds != None: 
      self.dataSource = _ds
      #if _object != None:
      #  self.initFromDataSource()
    else: self.dataSource = None
  
  # clearObject
  def clearObject(self):
    "clear the object"
    self.object = {}

  # has_key
  def has_key(self, _key):
    "check if object has a special key"
    return self.object.has_key(_key)

  def has_key_rec(self, _key):
    if self.has_key(_key): return _key
    if self.has_key('extendedAttrs'):
      if self.object['extendedAttrs'].has_key(_key): 
        return 'extendedAttrs.'+_key
    if self.has_key('phones'):
      if self.object['phones'].has_key(_key): 
        return 'phones.'+_key+'.number'

    return false

  # setName
  def setName(self, _value):
    "set the 'name' attribute"
    self.setAttribute('name',_value)

  # getName
  def getName(self):
    "get the 'name' attribute"
    return self.getAttribute('name')

  # getNumber
  def getNumber(self):
    "get the 'number' attribute"
    return self.getAttribute('number')

  # setAttribute  
  def setAttribute(self, _attribute, _value):
    "setAttribute() - sets an attribute"
    if _value != '' and _value != None:
      if string.find(_attribute,'.') == -1:
        self.object[_attribute] = _value
      else:
        levels = string.split(_attribute,'.')
        current = self.object
        for level in levels[:-1]:
          if current.has_key(level) != 1:
            current[level] = {}
          current = current[level]
        current[levels[-1]] = _value

  # getAttribute
  def getAttribute(self, _attribute):
    "getAttribute() - gets an attribute"
    if self.object.has_key(_attribute):
      return self.object[_attribute]
    elif string.find(str(_attribute),'.') != -1:
      levels = string.split(str(_attribute),'.')
      current = self.object
      for level in levels[:-1]:
        current = current[level]
      return current[levels[-1]]

  # addElement
  def addElement(self, _key, _value):
    "add an element to an array"
    if not self.object.has_key(_key):
      self.object[_key] = [_value,]
    else:
      self.object[_key].append(_value)

  # getDictionary
  def getDictionary(self):
    "get the object dictionary"
    return self.object

  # setAddress
  def setAddress(self, _type, _name1=None, _name2=None, _name3=None,
                 _street=None, _city=None, _zip=None, _country=None):
    "set the address"
    self.setAttribute('address.'+_type+'.type'    ,_type)
    self.setAttribute('address.'+_type+'.name1'   ,_name1)
    self.setAttribute('address.'+_type+'.name2'   ,_name2)
    self.setAttribute('address.'+_type+'.name3'   ,_name3)
    self.setAttribute('address.'+_type+'.street'  ,_street)
    self.setAttribute('address.'+_type+'.city'    ,_city)
    self.setAttribute('address.'+_type+'.zip'     ,_zip)
    self.setAttribute('address.'+_type+'.country' ,_country)

    self.addElement('addressTypes',_types)

  # setPhone
  def setPhone(self, _type, _number=None, _info=None):
    "set the phone number and info"
    self.setAttribute('phones.'+_type+'.type'   ,_type)
    self.setAttribute('phones.'+_type+'.number' ,_number)
    self.setAttribute('phones.'+_type+'.info'   ,_info)

    self.addElement('phoneTypes',_type)

  # setDataSource
  def setDataSource(self, _dataSource):
    "set the dataSource for this object"
    self.dataSource = _dataSource

  # saveObject
  def saveObject(self):
    "save this object (insert/update)"
    print self.object
    if self.getAttribute('globalID') == None:
      self.dataSource.insertObject(self.object)
    else: self.dataSource.updateObject(self.object)

  def deleteObject(self):
    "delete an object"
    self.dataSource.deleteObject(self.object)
      
  # initFromDataSource
  def initFromDataSource(self):
    "init the object from a given dataSource"
    self.object = self.dataSource.fetchObjects()[0]

  # __setitem__
  def __setitem__(self, _attribute, _value):
    "__setitem__ - sets an item"
    self.setAttribute(_attribute, _value)

  # __getitem__
  def __getitem__(self, _attribute):
    "__getitem__ - gets an item"
    return self.getAttribute(_attribute)

  # __repr__
  def __repr__(self):
    "__repr__ - get a representation of the item"
    output = ''
    for key in self.object.keys():
      output = output + "> %-12s : %s\n" % (str(key), str(self.object[key]))
    return output

