#----------------------------------------------------------------------------
# Name:         XmlRpcDataSource.py
# Author:       Bjoern
# Created:      09/24/2001
# Copyright:    (c) 2001 SKYRiX Software AG
#----------------------------------------------------------------------------

import string

class XmlRpcDataSource:
    
    def __init__(self, server,
                       fetchObjects=None,
                       insertObject=None,
                       updateObject=None,
                       deleteObject=None):
        self.server = server
        self.fetchSpecification = ''
        
        self.fetchObjectsAction = fetchObjects
        self.insertObjectAction = insertObject
        self.updateObjectAction = updateObject
        self.deleteObjectAction = deleteObject
        return;

    def setFetchSpecification(self, _fetchSpec):
        self.fetchSpecification = _fetchSpec;

    def fetchSpecification(self):
        return self.fetchSpecification;

    def addToFetchSpecification(self, _text, _keys, _conn = 'AND'):
      if _text != None and _text != '':
        _fs = self.fetchSpecification
        for count in range(len(_keys)):
          if len(_fs) == 0: andString = ''
          else: andString = ' ' + _conn + ' '
          _fs = _fs + andString + _keys[count] + " like '*" + _text + "*'"
        self.setFetchSpecification(_fs)
      return self.fetchSpecification

    def fetchObjects(self):
        return self.invokeMethod(self.fetchObjectsAction,
                                 [self.fetchSpecification])

    def insertObject(self, _obj):
        return self.invokeMethod(self.insertObjectAction, [_obj])
    
    def updateObject(self, _obj):
        return self.invokeMethod(self.updateObjectAction, [_obj])
    
    def deleteObject(self, _obj):
        return self.invokeMethod(self.deleteObjectAction, [_obj])

    def invokeMethod(self, _methodName, _params):
        result = None
        if (len(_methodName) > 0):
          action = self.server
          for tmp in string.split(_methodName, '.'):
            action = getattr(action, tmp)
          result = apply(action, _params)
        return result

