#!/usr/bin/env python

from wxPython.wx import *

def get_text(self, id):
  element = wxPyTypeCast(self.FindWindowById(id),'wxTextCtrl')
  if element:
    return element.GetValue()

def set_text(self, id, _text):
  element = wxPyTypeCast(self.FindWindowById(id),'wxTextCtrl')
  if element:
    if _text != None and _text != '':
      element.SetValue(str(_text))

def set_static(self, id, _text):
  element = wxPyTypeCast(self.FindWindowById(id),'wxStaticText')
  if element:
    if _text != None:
      element.SetLabel(str(_text))

def get_combobox(self, id):
  return wxPyTypeCast(self.FindWindowById(id), 'wxComboBox')

def get_choice(self, id):
  return wxPyTypeCast(self.FindWindowById(id),'wxChoice')

def fill_choice(self, _id,_list,_element=None):
  _choice = get_choice(self, _id)
  if _choice:
    for count in range(len(_list)):
      if _element != None: _choice.Append(_list[count][_element])
      else: _choice.Append(_list[count])
    _choice.SetSelection(0)  

def elem_choice(self, _id,_list,_element):
  _choice = get_choice(self, _id)
  if _choice:
    sel = _choice.GetSelection()
    if sel != 0:
      return _list[sel][_element]

def get_listbox(self, id):
  return wxPyTypeCast(self.FindWindowById(id),'wxListBox')

def get_listctrl(self, id):
  return wxPyTypeCast(self.FindWindowById(id),'wxListCtrl')

def get_tree(self, id):
  return wxPyTypeCast(self.FindWindowById(id), 'wxTreeCtrl')

def get_notebook(self, id):
  return wxPyTypeCast(self.FindWindowById(id),'wxNotebook')

wxFrame.getText = get_text
wxFrame.setText = set_text
wxFrame.getChoice = get_choice
wxFrame.fillChoice = fill_choice
wxFrame.elemChoice = elem_choice
wxFrame.getListBox = get_listbox
wxFrame.getComboBox = get_combobox
wxFrame.getListCtrl = get_listctrl
wxFrame.getNotebook = get_notebook
wxFrame.setStatic = set_static

wxDialog.getText = get_text
wxDialog.setText = set_text
wxDialog.getChoice = get_choice
wxDialog.fillChoice = fill_choice
wxDialog.elemChoice = elem_choice
wxDialog.getListBox = get_listbox
wxDialog.getComboBox = get_combobox
wxDialog.getNotebook = get_notebook

wxPanel.getText = get_text
wxPanel.setText = set_text
wxPanel.getChoice = get_choice
wxPanel.fillChoice = fill_choice
wxPanel.elemChoice = elem_choice
wxPanel.getListBox = get_listbox
wxPanel.getListCtrl = get_listctrl
wxPanel.getComboBox = get_combobox
wxPanel.getNotebook = get_notebook
wxPanel.getTree = get_tree
