#!/usr/bin/env python
#----------------------------------------------------------------------------
# Name:         wxDlgBusinessCardGather.py
# Author:       Bjoern
# Created:      09/25/2001
# Copyright:    (c) 2001 SKYRiX Software AG
#----------------------------------------------------------------------------

from wxPython.wx import *
from skyrix.Person import Person
from Dialog import *
from wxDlgGetContact import wxDlgGetContact
from wxSkyClient_wdr import dlgGatherBusinessCard
from wxSkyData import *

class wxDlgBusinessCardGather(wxFrame):

  # __init__
  def __init__(self, parent, id, title, app,
               pos = wxPyDefaultPosition, size = wxPyDefaultSize,
               style = wxRESIZE_BORDER|wxCAPTION|wxSYSTEM_MENU):

    wxFrame.__init__(self, parent, id, title, pos, size, style)

    self.parent = app.frame
    self.app = app
    
    wxInitAllImageHandlers()
    dlgGatherBusinessCard( self, true )
    self.CentreOnParent()
    
    self.salutation = getAddViewSalutationEntries()
    self.address = getAddAddressFields()
    self.fields = getAddTextFields()

    # fill the salutation wxChoice 
    self.fillChoice(ID_CHO_SALUTATION,self.salutation,0)
    
    EVT_BUTTON(self, ID_BTN_ADD, self.onAdd)
    EVT_BUTTON(self, ID_BTN_CANCEL, self.onCancel)
    EVT_BUTTON(self, ID_BTN_CONTACT, self.onContact)

  # onAdd
  def onAdd(self,event):
    "add the gathered business card"

    server = self.app.connectionList['person']
    record = Person(server)

    # 'normal' fields
    for count in range(len(self.fields)):
      field = self.fields[count]
      record[field[1]] = self.getText(field[0])

    # salutation
    record['salutation'] = self.elemChoice(ID_CHO_SALUTATION, self.salutation,1)

    # extended attributes
    record['extendedAttrs.email1'] = self.getText(ID_TXT_PRIVEMAIL)
    record['extendedAttrs.job_title'] = self.getText(ID_TXT_POSITION)

    # phones
    record.setPhone('01_tel',self.getText(ID_TXT_PHONE1),self.getText(ID_TXT_INFO1))
    record.setPhone('10_fax',self.getText(ID_TXT_FAX),self.getText(ID_TXT_INFO2))

    # addresses
    for count in range(len(self.address)):
      address = self.address[count]
      record['addresses.private.'+address[1]] = self.getText(address[0]+3000)

    record.saveObject()

  # onCancel
  def onCancel(self,event):
    "cancel business card gathering"
    self.Close()

  # onContact
  def onContact(self,event):
    "find a contact"
    text = self.getText(ID_TXT_CONTACT)
    
    if text != '':
      dlg = wxDlgGetContact(self, -1, 'Select Contact',text,self.app,'enterprise')
      if dlg.ShowModal() == wxID_OK:
        
        result = self.app.elementList[str(dlg.getResult())]
        self.setText(ID_TXT_CONTACT,result['name'])
        address = result['addresses.ship']
        
        for i in range(len(self.address)):
          if address.has_key(self.address[i][1]):
            self.setText(self.address[i][0]+3000, address[self.address[i][1]])
      
      dlg.Destroy()

