#!/usr/bin/env python
#----------------------------------------------------------------------------
# Name:         wxDlgCalendarSelect.py
# Author:       Bjoern
# Created:      09/25/2001
# Copyright:    (c) 2001 SKYRiX Software AG
#----------------------------------------------------------------------------

from wxPython.wx import *
from wxSkyClient_wdr import *
from skyrix.ui.Dialog import *
from wxPython.lib.calendar import wxCalendar, Month, PrtCalDraw, CalenDlg

class wxDlgCalendarSelect(wxDialog):
  
  # __init__
  def __init__(self, parent, id, title, date = None,
               pos = wxPyDefaultPosition, size = wxPyDefaultSize, 
               style = wxDEFAULT_DIALOG_STYLE ):

    wxDialog.__init__(self, parent, id, title, pos, size, style)

    self.result = ''

    # add foreign control
    self.calendar = wxCalendar(self, ID_CAL_CALENDAR,wxDefaultPosition,wxSize(300,200))

    # get the controls
    dlgCalendarSelect( self, true )
    self.CentreOnParent()

    for count in range(13):
      name = Month[count]
      if name != None: self.getChoice(ID_CHO_MONTH).Append(name)

    if date != '':
      self.calendar.SetYear(int(date[0:4]))
      self.calendar.SetMonth(int(date[5:7]))

    self.getChoice(ID_CHO_MONTH).SetSelection(self.calendar.GetMonth()-1)
    self.setText(ID_TXT_YEAR,self.calendar.GetYear())

    # WDR: handler declarations for wxDlgCalendarSelect

    EVT_CHOICE(self, ID_CHO_MONTH, self.onChoiceMonth)
    EVT_SPIN_UP(self, ID_SPB_YEAR, self.onSpinYearUp)
    EVT_SPIN_DOWN(self, ID_SPB_YEAR, self.onSpinYearDown)
    EVT_TEXT_ENTER(self, ID_TXT_YEAR, self.onYearEnter)

    # add handler for click on calendar
    self.Connect(self.calendar.GetId(),-1,2100,self.onCalendarClick)

  # WDR: methods for wxDlgCalendarSelect

  def getResult(self):
    return self.result

  # WDR: handler implementations for wxDlgCalendarSelect

  # onYearEnter
  # -> setting the year after pressing ENTER
  def onYearEnter(self,event):
    self.calendar.SetYear(int(self.getText(ID_TXT_YEAR))) 
    self.calendar.Refresh()

  # onChoiceMonth
  # -> set the calendar after changing the month
  def onChoiceMonth(self,event):
    self.calendar.SetMonth(self.getChoice(ID_CHO_MONTH).GetSelection()+1)
    self.calendar.Refresh()

  # onSpinYearUp
  # -> increase the year with the wxSpinButton
  def onSpinYearUp(self,event):
    year = int(self.getText(ID_TXT_YEAR))
    year = year + 1
    self.setText(ID_TXT_YEAR,str(year))
  
    self.calendar.SetYear(year)
    self.calendar.Refresh()

  # onSpinYearDown
  # -> decrease the year with the wxSpinButton
  def onSpinYearDown(self,event):
    year = int(self.getText(ID_TXT_YEAR))
    year = year - 1
    self.setText(ID_TXT_YEAR,str(year))

    self.calendar.SetYear(year)
    self.calendar.Refresh()
 
  # onCalendarClick
  # -> select a date
  def onCalendarClick(self,event):
    if event.month < 10:
      monthString = '0' + str(event.month)
    else:
      monthString = event.month

    if event.day < 10:
      dayString = '0' + str(event.day)
    else:
      dayString = event.day

    self.result = '%4s-%2s-%2s' % (event.year, monthString, dayString)
    
    self.EndModal(wxID_OK)

