#!/usr/bin/env python
#----------------------------------------------------------------------------
# Name:         wxDlgEditAttributes.py
# Author:       Bjoern
# Created:      09/26/2001
# Copyright:    (c) 2001 SKYRiX Software AG
#----------------------------------------------------------------------------

from wxPython.wx import *
from wxSkyClient_wdr import dlgEditAttributes, ID_LST_ATTRIBUTES, ID_BTN_SAVE, ID_BTN_CANCEL

class wxDlgEditAttributes(wxFrame):

  # __init__
  def __init__(self,parent,id,directory, app):
   
    # those are readonly values - they are only shown
    # and deleted from the attributes dictionary after
    # inserting in the listCtrl
    self.readonly = ['NSFilePath',
                     'SkyLastModifiedDate',
                     'NSFileOwnerAccountName',
                     'SkyFirstOwnerId',
                     'filename',
                     'versionCount',
                     'NSFileModificationDate',
                     'fileType',
                     'NSFileName',
                     'NSFileMimeType',
                     'SkyStatus',
                     'NSFileSize',
                     'SkyVersionCount',
                     'SkyCreationDate',
                     'SkyFileName',
                     'globalID',
                     'fileSize',
                     'SkyFilePath',
                     'creationDate',
                     'SkyIsVersion',
                     'NSFileOwnerAccountNumber',
                     'lastmodifiedDate',
                     'NSFileType',
                     'SkyOwnerId',
                     'status' ]

    self.path = directory
    self.app = app
    self.dataSource = self.app.connectionList['project']
    self.attributes = self.dataSource.attributesAtPath(self.path)
    
    wxFrame.__init__(self,parent,-1,'Edit Attributes',size=wxSize(600,450))

    dlgEditAttributes(self,true)
    list = self.getListCtrl(ID_LST_ATTRIBUTES)
   
    EVT_LIST_ITEM_ACTIVATED(list,-1,self.onItemActivated)
    
    list.InsertColumn(0,"Attribute")
    list.InsertColumn(1,"Value")

    list.SetColumnWidth(0, 250)
    list.SetColumnWidth(1, 320)
    
    p = 0
    for key in self.attributes.keys():
      list.InsertStringItem(p,key)
      
      ro = false
      for i in range(len(self.readonly)):
        if key == self.readonly[i]: ro = true

      if ro:
        list.SetStringItem(p,1,'ro: ' + self.attributes[key])
        del self.attributes[key]
      else:
        list.SetStringItem(p,1,self.attributes[key])
      p = p+1

    EVT_BUTTON(self,ID_BTN_SAVE,self.onSave)
    EVT_BUTTON(self,ID_BTN_CANCEL,self.onCancel)

    self.CentreOnScreen()
    self.Show(true)

  # onItemActivated
  # -> edit item in list
  def onItemActivated(self,event):
    list = self.getListCtrl(ID_LST_ATTRIBUTES)
    itemName = list.GetItemText(event.m_itemIndex)
    if self.attributes.has_key(itemName):
      dlg = wxTextEntryDialog(self,itemName,'Edit Value',self.attributes[itemName])
      if dlg.ShowModal() == wxID_OK:
        self.attributes[itemName] = dlg.GetValue()
        list.SetStringItem(event.m_itemIndex,1,dlg.GetValue())

  # onSave
  # -> safe the changed attributes
  def onSave(self,event):
    self.dataSource.writeAttributesAtPath(self.path,self.attributes)
    self.Close()

  # onCancel
  # -> cancel the editing
  def onCancel(self,event):
    self.Close() 

