#!/usr/bin/env python
#----------------------------------------------------------------------------
# Name:         wxDlgEditFile.py
# Author:       Bjoern
# Created:      09/25/2001
# Copyright:    (c) 2001 SKYRiX Software AG
#----------------------------------------------------------------------------

from wxPython.wx import *
from wxPython.stc import *
from wxSkyClient_wdr import *
from skyrix.ui.Dialog import *

class wxDlgEditFile(wxFrame):
  
  # __init__
  def __init__(self, parent, id, title, app, file=None, 
               pos = wxPyDefaultPosition, size = wxPyDefaultSize, 
               style = wxDEFAULT_FRAME_STYLE ):

    wxFrame.__init__(self, parent, id, title, pos, size, style)

    self.app = app
    self.file = file

    # add foreign control
    self.editCtrl = wxStyledTextCtrl(self, ID_STY_EDIT,wxDefaultPosition,wxSize(500,500))

    self.editCtrl.SetMarginType(0, wxSTC_MARGIN_NUMBER)
    self.editCtrl.SetMarginWidth(0,22)

    # get the controls
    dlgEditFile(self, true)

    EVT_BUTTON(self,ID_BTN_SAVE,self.onSave)
    EVT_BUTTON(self,ID_BTN_CANCEL,self.onCancel)

    self.dataSource = self.app.connectionList['project']
    if self.dataSource.fileExistsAtPath(file):
      self.editCtrl.SetText(self.dataSource.contentsAtPath(file))
    
    self.CentreOnParent()
    self.Show(true)
  
  # onCancel
  def onCancel(self,event):
    "cancel the editing"
    self.Close()

  # onSave
  def onSave(self,event):
    "save the file"
    self.dataSource.writeContentsAtPath(self.editCtrl.GetText(),self.file)
    self.Close() 
