#!/usr/bin/env python
#----------------------------------------------------------------------------
# Name:         wxDlgGetContact.py
# Author:       Bjoern
# Created:      09/07/2001
# Copyright:    (c) 2001 SKYRiX Software AG
#----------------------------------------------------------------------------

from wxPython.wx import *
from wxSkyClient_wdr import *
from skyrix.ui.Dialog import *

class wxDlgGetContact(wxDialog):

  # __init__
  def __init__(self, parent, id, title, search, app, source='person',
               pos = wxPyDefaultPosition, size = wxPyDefaultSize, 
               style = wxDEFAULT_DIALOG_STYLE ):

    wxDialog.__init__(self, parent, id, title, pos, size, style)
    wxInitAllImageHandlers()

    dlgGetContact( self, true )

    EVT_BUTTON(self,ID_BTN_OK,self.onOk)
    EVT_BUTTON(self,ID_BTN_CANCEL,self.onCancel)

    self.app = app
    listBox = self.getListBox(ID_LST_CONTACTS)
      
    fs_ = ''

    if source == 'person': keys = ['name','nickname','firstname','login']
    else: keys = ['name','number']
   
    server = self.app.connectionList[source]
    server.addToFetchSpecification(search,keys,'OR')
    self.app.elementList = server.fetchObjects()

    personList = {}
  
    for i in self.app.elementList.keys():
      entry = self.app.elementList[i]
      personList[entry['number']] = entry['name']
      listBox.Append(entry['name'] + ' [' + entry['number'] + ' ]')

  def getResult(self):
    return self.contact

  # onOK
  # -> get the selected person from the dialog
  def onOk(self,event):
    name = self.getListBox(ID_LST_CONTACTS).GetStringSelection()
    self.contact = name[string.find(name,'[')+1:string.find(name,']')-1]

    self.EndModal(wxID_OK)

  # onCancel
  # -> close the dialog
  def onCancel(self,event):
    self.Destroy()

