#!/usr/bin/env python
#----------------------------------------------------------------------------
# Name:         wxDlgMakeConnection.py
# Author:       Bjoern
# Created:      09/25/2001
# Copyright:    (c) 2001 SKYRiX Software AG
#----------------------------------------------------------------------------

from wxPython.wx import *
from skyrix.ui.Dialog import *
import skyrix.thirdparty.xmlrpclib as xmlrpclib
from skyrix import PersonDataSource,EnterpriseDataSource, ProjectFileManager
from wxSkyClient_wdr import *

class wxDlgMakeConnection(wxDialog):

  # __init__
  def __init__(self, parent, id, title, app, type=None,
               pos = wxPyDefaultPosition, size = wxPyDefaultSize,
               style = wxDEFAULT_DIALOG_STYLE ):

    wxDialog.__init__(self, parent, id, title, pos, size, style)

    dlgMakeConnection( self, true )
    self.CentreOnParent()
    self.app = app
    self.type = type

    self.setText(ID_TXT_HOSTNAME, app.config.getValue('server.host'))
    self.setText(ID_TXT_PORT, app.config.getValue('server.port'))
    self.setText(ID_TXT_USER, app.config.getValue('server.user'))
    self.setText(ID_TXT_PASSWORD, app.config.getValue('server.password'))
    self.setText(ID_TXT_PATH, app.config.getValue('server.path'))

    EVT_BUTTON(self, ID_BTN_CONNECT, self.onConnect)

  # WDR: handler implementations for wxDlgMakeConnection

  # onConnect
  # -> connect to an XMLRPC Server
  def onConnect(self, event):

    _login = self.getText(ID_TXT_USER)
    _password = self.getText(ID_TXT_PASSWORD)
    _url = 'http://'+self.getText(ID_TXT_HOSTNAME)+':'+  \
                    self.getText(ID_TXT_PORT)+self.getText(ID_TXT_PATH)

    host = self.getText(ID_TXT_HOSTNAME)
    self.app.host = host

    # person dataSource
    server = xmlrpclib.Server(_url,login=_login,password=_password)

    if self.type == None:
      self.app.connectionList['person']= PersonDataSource(server)
      self.app.connectionList['enterprise']= EnterpriseDataSource(server)
      self.app.connectionList['ping'] = server

    else:
      if self.type == 'person' or self.type == 'enterprise':
        self.app.connectionList['person'] = PersonDataSource(server)
        self.app.connectionList['enterprise'] = EnterpriseDataSource(server)
        self.app.connectionList['ping'] = server
        self.EndModal(wxID_OK)
      if self.type == 'project':
        self.app.connectionList['project'] = ProjectFileManager(_login,_password,
                                                       host,self.getText(ID_TXT_PORT))

    self.EndModal(wxID_OK)

