#!/usr/bin/env python
#----------------------------------------------------------------------------
# Name:         wxDlgViewDocument.py
# Author:       Bjoern
# Created:      09/25/2001
# Copyright:    (c) 2001 SKYRiX Software AG
#----------------------------------------------------------------------------

from wxPython.wx import *
from skyrix.ui.Dialog import *
from wxSkyData import *
from wxDlgAddEditDocument import wxDlgAddEditDocument

class wxDlgViewDocument(wxFrame):

  # __init__
  def __init__(self, parent, id, title, app, record,type,
               pos = wxPyDefaultPosition, size = wxPyDefaultSize, 
               style = wxDEFAULT_DIALOG_STYLE ):

    wxFrame.__init__(self, parent, id, title, pos, size, style)
    
    self.type = type
    self.app = app
    self.record = record
    self.parent = parent
    self.extAttr = getMainExtAttr()

    if type == 'person': dlgViewPerson( self, true )
    else: dlgViewEnterprise( self, true )
  
    self.CentreOnParent()

    # get all the structures 
    self.controls = getViewStaticFields()
    self.extended = getViewExtendedFields()
    self.address = getViewAddressFields()
    self.salutation = getAddViewSalutationEntries()
    self.phone = getViewPhoneFields()

    if record != '':

      self.result = self.app.elementList[record]
      
      if type == 'person':
        self.SetTitle('Viewing person (' + self.result['name'] + ', ' +
                                           self.result['firstname'] +')')
      else:  
        self.SetTitle('Viewing enterprise (' + self.result['name'] + ')')

      # 'normal' controls
      for count in range(len(self.controls)):
        self.setStatic(self.controls[count][0],self.result[self.controls[count][1]])

      # addresses
      if self.app.appType == 'person':
        self.addresses = ['private','mailing','location']
      else: self.addresses = ['ship','bill']
     
      theRecord = self.result['addresses']
      for count in range(len(self.addresses)):
        if theRecord.has_key(self.addresses[count]):
          address = theRecord[self.addresses[count]]
          for i in range(len(self.address)):
            if address.has_key(self.address[i][1]):
              self.setStatic(self.address[i][0]+(count*1000),address[self.address[i][1]])

      # salutation
      for count in range(len(self.salutation)):
        if self.salutation[count][1] == self.result['salutation']:
          self.setStatic(ID_STA_SALUTATION,self.salutation[count][0])
          break;

      # birthday
      if self.result.has_key('birthday'):
        self.setStatic(ID_STA_BIRTHDAY,self.result.getBirthday())

      # phones
      if self.result.has_key('phones'):
        phoneNumbers = self.result['phones']
        for key in self.phone.keys():
          if phoneNumbers.has_key(key):
            self.setStatic(self.phone[key],phoneNumbers[key]['number'])
            self.setStatic(self.phone[key]+1,phoneNumbers[key]['info'])

      # extended keys
      extendedKeys = self.result['extendedKeys']
      extendedAttrs = self.result['extendedAttrs']
      
      attrList = self.getListCtrl(ID_LST_EXTATTR)

      attrList.InsertColumn(0,'Attribute')
      attrList.InsertColumn(1,'Value')
      attrList.SetColumnWidth(0,300)
      attrList.SetColumnWidth(1,300)

      insPos = 0
      for count in range(len(extendedKeys)):
        extKey = extendedKeys[count]
        if extendedAttrs.has_key(extKey):
          if self.extended.has_key(extKey):
            self.setStatic(self.extended[extKey],extendedAttrs[extKey])
          if self.extAttr.has_key(extKey):
            addString = self.extAttr[extKey]
          else: addString = extKey
          attrList.InsertStringItem(insPos,addString)
          attrList.SetStringItem(insPos,1,extendedAttrs[extKey])
          insPos = insPos + 1

    # WDR: handler declarations for wxDlgViewPerson

    EVT_BUTTON(self, ID_BTN_OK, self.onOk)
    EVT_BUTTON(self, ID_BTN_EDIT, self.onEdit)

  # onEdit
  # -> open edit dialog
  def onEdit(self,event):
    frame = wxDlgAddEditDocument(self.parent,-1,'Edit person ' + self.record,self.app,self.record, self.type)
    frame.Show(true)
    self.Close()

  # onOK
  # -> close dialog
  def onOk(self,event):
    self.Close(true)

