#!/usr/bin/env python

from wxSkyClient_wdr import *

def getSkyCategories():
  # __main__
  return [ ('firstname'  , 'First name')  ,
           ('middlename' , 'Middle name') ,
           ('name'       , 'Name')        ,
           ('number'     , 'Number')      ,
           ('nickname'   , 'Nickname')    ,
           ('salutation' , 'Salutation')  ,
           ('degree'     , 'Degree')      ,
           ('url'        , 'URL')         ,
           ('gender'     , 'Gender')      ,
           ('birthday'   , 'Birthday')    ,
           ('comment'    , 'Comment')     ,
           ('keywords'   , 'Keywords')    ,
           ('login'      , 'Login')       ,
      
           # additional enterprise information

           ('priority'   , 'Priority')    ,
           ('bank'       , 'Bank')        ,
           ('bankCode'   , 'Bank Code')   ,
           ('account'    , 'Bank Account'),
           ('email'      , 'EMail')
        ]

def getMainMaxRes():
  # __main__
  return ['100','200','500','600','1000']

def getMainExtAttr():
  # __main__
  return { 'email1'       : 'Email 1'       ,
           'email2'       : 'Email 2'       ,
           'job_title'    : 'Position'      ,
           'other_title1' : 'Other Title 1' ,
           'other_title2' : 'Other Title 2'
         }

def getMainPhones():
  # __main__
  return  [ ('All Phones/Fax' , '')               ,
            ('Telephone 1'    , '01_tel')         ,
            ('Telephone 2'    , '02_tel')         ,
            ('Mobile'         , '0_mobile')      ,
            ('Fax'            , '10_fax')         ,
            ('Tel private'    , '05_tel_private') ,
            ('Fax private'    , '15_fax_private')  
          ]                    

def getMainFields():
  # __main__
  return [ # person attributes
           (ID_TXT_NAME      ,'name')           ,
           (ID_TXT_FIRSTNAME ,'firstname')      ,
           (ID_TXT_ZIPCODE   ,'address.zip')    ,
           (ID_TXT_LOCATION  ,'address.city')   ,
           (ID_TXT_STREET    ,'address.street') ,
           (ID_TXT_EMAIL     ,'email1')         ,
           (ID_TXT_URL       ,'url')            ,
           (ID_TXT_NOTES     ,'comment')        ,
           # additional enterprise attributes
           (ID_TXT_COUNTRY   ,'address.country'),
           (ID_TXT_NUMBER    ,'number')
         ]

def getViewStaticFields():
  # wxDlgViewPerson
  # -> static text controls
  return [ (ID_STA_NAME       , 'name')       ,
           (ID_STA_MIDDLENAME , 'middlename') ,
           (ID_STA_FIRSTNAME  , 'firstname')  ,
           (ID_STA_NICKNAME   , 'nickname')   ,
           (ID_STA_DEGREE     , 'degree')     ,
           (ID_STA_GENDER     , 'sex')        ,
           (ID_STA_URL        , 'url')        ,
           (ID_STA_CATEGORY   , 'keywords')   ,
           (ID_STA_VERSION    , 'objectVersion')    ,
           (ID_STA_OWNER      , 'owner')      ,
           (ID_STA_COMMENT    , 'comment')
         ]

def getViewExtendedFields():
  # wxDlgViewPerson
  # -> static text controls for extAttr
  return { 'email1' : ID_STA_EMAIL1     ,
           'email2' : ID_STA_EMAIL2
         }

def getViewAddressFields():
  # wxDlgViewPerson
  # -> static text field for addresses
  return [ (ID_STA_NAME11   , 'name1')  ,
           (ID_STA_NAME21   , 'name2')  ,
           (ID_STA_NAME31   , 'name3')  ,
           (ID_STA_STREET1  , 'street') ,
           (ID_STA_CITY1    , 'city')   ,
           (ID_STA_ZIP1     , 'zip')    ,
           (ID_STA_STATE1   ,'state')   ,
           (ID_STA_COUNTRY1 ,'country')
         ]

def getAddViewSalutationEntries():
  # wxDlgViewPerson
  # wxDlgAddEditPerson
  # -> entries for salutation wxChoice
  return [ ('-'          ,'00_nothing'),
           ('Dear Ms.'   ,'01_dear_ms'),
           ('Dear Mrs.'  ,'02_dear_mrs'),
           ('Dear Mr.'   ,'03_dear_mr'),
           ('Dear Prof.' ,'04_dear_prof'), 
           ('Dear Dr.'   ,'05_dear_dr'),
           ('Herr'       ,'06_herr'),
           ('Frau'       ,'07_frau'),
           ('Herr Prof.' ,'08_herr_prof'),
           ('Herr Dr.'   ,'09_herr_dr'),
           ('Frau Prof.' ,'10_frau_prof'),
           ('Frau Dr.'   ,'11_frau_dr')
         ]

def getViewPhoneFields():
  # wxDlgViewPerson
  # -> phone fields and types
  return { '01_tel'         : ID_STA_PHONE1,
           '02_tel'         : ID_STA_PHONE2,
           '05_tel_private' : ID_STA_PHONE_PRIV,
           '10_fax'         : ID_STA_FAX,
           '15_fax_private' : ID_STA_FAX_PRIV
         }
 
def getAddGenderEntries():
  # wxDlgAddEditPerson
  return ['-', 'male' , 'female', 'undefined' ]

def getAddPhoneFields():
  # wxDlgAddEditPerson
  return [ (ID_TXT_PHONE1     , '01_tel'),
           (ID_TXT_PHONE2     , '02_tel'),
           (ID_TXT_PHONE_PRIV , '05_tel_private'),
           (ID_TXT_FAX        , '10_fax'),
           (ID_TXT_FAX_PRIV   , '15_fax_private')
         ]
  
def getAddAddressKeys():
  # wxDlgAddEditPerson
  return ['private', 'mailing', 'location' ]  

def getAddEnterpriseAddressKeys():
  # wxDlgAddEditPerson
  return ['ship', 'bill']  

def getAddAddressFields():
  # wxDlgAddEditPerson
  return [ (ID_TXT_NAME11   , 'name1'),
           (ID_TXT_NAME21   , 'name2'),
           (ID_TXT_NAME31   , 'name3'),
           (ID_TXT_STREET1  , 'street'),
           (ID_TXT_CITY1    , 'city'),
           (ID_TXT_ZIP1     , 'zip'),
           (ID_TXT_STATE1   , 'state'),
           (ID_TXT_COUNTRY1 , 'country')
         ]

def getAddPhoneInfoFields():
  # wxDlgAddEditPerson
  return [ ID_TXT_PHONE1_INFO     ,
           ID_TXT_PHONE2_INFO     ,
           ID_TXT_PHONE_PRIV_INFO ,
           ID_TXT_FAX_INFO        ,
           ID_TXT_FAX_PRIV_INFO   
         ]

def getAddTextFields():
  # wxDlgAddEditPerson
  return [ (ID_TXT_LASTNAME   ,'name')       ,
           (ID_TXT_MIDDLENAME ,'middlename') ,
           (ID_TXT_FIRSTNAME  ,'firstname')  ,
           (ID_TXT_NICKNAME   ,'nickname')   ,
           (ID_TXT_DEGREE     ,'degree')     ,
           (ID_TXT_URL        ,'url')        ,
    
           # additional enterprise information
           (ID_TXT_EMAIL      ,'email')      ,
           (ID_TXT_BANK       ,'bank')       ,
           (ID_TXT_BANKCODE   ,'bankcode')   ,
           (ID_TXT_NUMBER     ,'number')     ,
           (ID_TXT_ACCOUNT    ,'account')    ,
         ]
