#!/usr/bin/env python
#----------------------------------------------------------------------------
# Name:         wxSkyClient.py
# Author:       bjoern
# Created:      09/24/2001
# Copyright:    (c) 2001 SKYRiX Software AG
#----------------------------------------------------------------------------

import skyrix.thirdparty.xmlrpclib as xmlrpclib
from skyrix import PersonDataSource, EnterpriseDataSource, ProjectFileManager
from skyrix.ui import wxDlgSkyClient
from wxPython.wx import *
from wxSkyConfig import *

# App
class App(wxApp):

  # OnInit
  def OnInit(self):
    self.config = wxSkyConfig()
    self.connectionList = {}
    self.elementList = {}

    # FIXME
    self.values = []
    self.frame = wxDlgSkyClient(None, -1, self)
    self.SetTopWindow(self.frame)
    return true

  # autoConnect
  # -> autoconnect if key is set in the config
  def autoConnect(self):
    config = self.config
    
    _user = config.getValue('server.user')
    _pass = config.getValue('server.password')
    _url  = 'http://' + config.getValue('server.host')+':'+\
            config.getValue( 'server.port')+\
            config.getValue('server.path')

    host = config.getValue('server.host')
 
    list = self.connectionList
   
    server = xmlrpclib.Server(_url, login=_user, password=_pass)

    list['person'] = PersonDataSource( server)
    list['enterprise'] = EnterpriseDataSource( server)
    list['project'] = ProjectFileManager(_user,_pass,host,'10817')
    list['ping'] = server

    self.frame.SetStatusText('Autoconnected to %s' % config.getValue( 'server.host'),0)
    self.isConnected = true

  def checkIfConnected(self, type):
    if self.connectionList.has_key(type): 
      return true
    else:
      self.frame.onMenuConnect(-1)
      return false

# __main__
if __name__ == '__main__':
  app = App(0)
  if app.config.getValue('server.autoconnect'): app.autoConnect()
  app.frame.onButtonContacts(-1)
  app.MainLoop()

